/* ----------------------------------------------------------------- */
/* UPCO ICAI - Departamento de Electrnica y Automtica              */
/* ----------------------------------------------------------------- */
/* Cdigo biblioteca stdlib: Funciones de conversin                 */
/*                                                                   */
/* Autor: David Garca Granda & Fernando Ibez Barrado              */
/* Fecha: 27 / 10 / 1999                                             */
/* Versin: 1.0                                                      */
/*                                                                   */
/* ----------------------------------------------------------------- */

#include "stdlib.h"

int miatoi(char *s)
{
	int i,n;
	n=0;
    if (s[0]=='-')  /* detecta si se ha introducido con signo */
    {
       for(i=1;(s[i]>='0')&&(s[i]<='9');i++)
           n=n*10+(s[i]-'0');
       n=-n;
    }
    else if (s[0]=='+')

       for(i=1;(s[i]>='0')&&(s[i]<='9');i++)
       n=n*10+(s[i]-'0');

    else     /* caso de no introducir signo alguno */

       for(i=0;(s[i]>='0')&&(s[i]<='9');i++)
       n=n*10+(s[i]-'0');
    
    return n;
}


char *miitoa(int i,char *s,int b)
{

int n,k;
int signo=1;
unsigned int j;
char temp[MAXLINEA],temp2[MAXLINEA];

if (b==10)              /* detecta el signo en caso de base 10 */
   if (i<0)
   {
      i=abs(i);
      signo=-1;
   }

j=i;

for (n=0;j/b>=1;j/=b){

    if ((j%b)>=10)
        temp[n]='A'+j%b-10;  /* para base 16 */
    else
        temp[n]=j%b+'0';  
    n++;
    }

if ((j%b)>=10)          /* escribe el ltimo cociente */
   temp[n]='A'+j%b-10;        /* para base 16 */
else
    temp[n]=j+'0';

temp[n+1]='\0';  /* finaliza la cadena */

if (signo==-1)        /* pone el signo, si procede, en base 10 */
   {
   temp2[0]='-';
   for (k=1;n>=0;n--,k++)  /* invierte el orden de la cadena */
       temp2[k]=temp[n];
   }
else
    for (k=0;n>=0;n--,k++)
        temp2[k]=temp[n];

temp2[k]='\0';


s=temp2;
return s;
}